global function Init_TitanLimit
global function GiveTitanAll

struct {
    array<entity> waitList
    int maxTitans = 3
} file

void function Init_TitanLimit()
{
    ServerCommand("exec autoexec_max_titans")

    SetCallback_EarnMeterGoalEarned( EarnMeterMP_TitanEarned )
    AddSpawnCallback("npc_titan", UpdateTitanAvailability )

    thread RunTitanfallAvailabiltyCheck()

    file.maxTitans = GetConVarInt("TitanLimit")
}

void function EarnMeterMP_TitanEarned( entity player )
{
    if ( CanPlayerHaveTitan( player ) && CanDropTitanChassis( player ) )
    {
        if ( EarnMeterMP_IsTitanEarnGametype() )
        {
            SetTitanAvailable( player )
            //Remote_CallFunction_Replay( player, "ServerCallback_TitanReadyMessage" ) // broken for some reason
        }
        else
        {
            float oldRewardFrac = PlayerEarnMeter_GetRewardFrac( player )
            PlayerEarnMeter_Reset( player )
            PlayerEarnMeter_SetRewardFrac( player, oldRewardFrac )
            PlayerEarnMeter_EnableReward( player )

            if ( PlayerEarnMeter_GetRewardFrac( player ) != 0 )
                PlayerEarnMeter_EnableReward( player )
        }
    }
    else
    {
        float oldRewardFrac = PlayerEarnMeter_GetRewardFrac( player )
        PlayerEarnMeter_Reset( player )
        PlayerEarnMeter_SetRewardFrac( player, oldRewardFrac )
        PlayerEarnMeter_EnableReward( player )

        if ( PlayerEarnMeter_GetRewardFrac( player ) != 0 )
            PlayerEarnMeter_EnableReward( player )
        
        if ( CanDropTitanChassis( player ) )
            Chat_ServerPrivateMessage( player, "Too many titans on the battle field", false)
        else
            Chat_ServerPrivateMessage( player, "This chassis is deployed too much on the battle field", false)

        ClearTitanAvailable( player )

        foreach( entity p in file.waitList )
        {
            if ( p == player )
                return
        }
        print( "added to list" )
        file.waitList.append( player )
    } 
}

bool function CanPlayerHaveTitan( entity player )
{
    int team = player.GetTeam()
    int titanCount = 0

    foreach ( entity titan in GetEntArrayByClass_Expensive("npc_titan") )
    {
        if ( titan.GetTeam() == team )
        {
            titanCount += 1
        }
    }
    foreach ( entity p in GetPlayerArray() )
    {
        if ( p.GetTeam() == team && p.IsTitan() )
        {
            titanCount += 1
        }
    }
    return !(file.maxTitans <= titanCount)
}

bool function CanTeamHaveTitan( int team )
{
    int titanCount = 0

    foreach ( entity titan in GetEntArrayByClass_Expensive("npc_titan") )
    {
        if ( titan.GetTeam() == team )
        {
            titanCount += 1
        }
    }
    foreach ( entity p in GetPlayerArray() )
    {
        if ( p.GetTeam() == team && p.IsTitan() )
        {
            titanCount += 1
        }
    }
    return !(file.maxTitans <= titanCount)
}

void function RunTitanfallAvailabiltyCheck()
{
    entity player
    for(;;)
    {
        bool MilitiaTf = CanTeamHaveTitan( TEAM_MILITIA )
        bool ImcTf = CanTeamHaveTitan( TEAM_IMC )


        for ( int i = file.waitList.len() - 1; i >= 0; i-- )
        {
            player = file.waitList[i]
            if ( !IsValid( player ) )
            {
                file.waitList.remove( i )
            }
            else if ( ( ( player.GetTeam() == TEAM_MILITIA && MilitiaTf ) || ( player.GetTeam() == TEAM_IMC && ImcTf ) ) && CanDropTitanChassis( player ) )
            {
                Chat_ServerPrivateMessage( player, "There is now space for a titan", false)
                file.waitList.remove( i )
                PlayerEarnMeter_Reset( player )
                player.p.earnMeterOverdriveFrac = 1.0
                player.SetPlayerNetFloat( EARNMETER_EARNEDFRAC, 1.0 )
                PlayerEarnMeter_SetOwnedFrac( player, 1.0 )
                PlayerEarnMeter_SetRewardFrac( player, 1.0 )
            }
        }

        wait 0.1
    }
}

void function GiveTitanAll()
{
    foreach( entity player in GetPlayerArray() )
    {
        player.p.earnMeterOverdriveFrac = 1.0
        player.SetPlayerNetFloat( EARNMETER_EARNEDFRAC, 1.0 )
        PlayerEarnMeter_SetOwnedFrac( player, 1.0 )
        PlayerEarnMeter_SetRewardFrac( player, 1.0 )
    }
}


void function UpdateTitanAvailability(entity npcTitan)
{
    Assert( IsMultiplayer() )

    string settingsFile = GetNPCTitanSettingFile( npcTitan )

    // TitanLoadoutDef loadout = expect TitanLoadoutDef( GetTitanLoadoutForPrimary( primary ) )
}

/////////////////////////////////////////////////////////////////////////////////////////
//                      Just a function from an other file :)
/////////////////////////////////////////////////////////////////////////////////////////


// TitanLoadoutDef function GetTitanLoadoutFromPlayerInventory( entity player ) //TODO: Examine necessity for this? Was needed in R1 where TItans could pick up weapons off the ground, but may not be needed in R2 anymore. Might just be fine to call GetTitanLoadoutForPlayer()
// {
// 	TitanLoadoutDef loadout = GetTitanLoadoutForPlayer( player )
// 	loadout.setFile = player.GetPlayerSettings()
// 	loadout.setFileMods = UntypedArrayToStringArray( player.GetPlayerSettingsMods() )

// 	array mainWeapons = player.GetMainWeapons()
// 	if ( mainWeapons.len() )
// 	{
// 		entity wep = player.GetMainWeapons()[0]
// 		loadout.primary = wep.GetWeaponClassName()
// 		loadout.primaryMods = wep.GetMods()
// 	}

// 	entity ord = player.GetOffhandWeapon(OFFHAND_ORDNANCE)
// 	if ( ord )
// 	{
// 		loadout.ordnance = ord.GetWeaponClassName()
// 		loadout.ordnanceMods = ord.GetMods()
// 	}

// 	entity tac = player.GetOffhandWeapon(OFFHAND_SPECIAL)
// 	if ( tac )
// 	{
// 		loadout.special = tac.GetWeaponClassName()
// 		loadout.specialMods = tac.GetMods()
// 	}

// 	entity antirodeo = player.GetOffhandWeapon(OFFHAND_ANTIRODEO)
// 	if ( antirodeo )
// 	{
// 		loadout.antirodeo = antirodeo.GetWeaponClassName()
// 		loadout.antirodeoMods = antirodeo.GetMods()
// 	}

// 	entity melee = player.GetMeleeWeapon()
// 	if ( melee )
// 		loadout.melee = melee.GetWeaponClassName()

// 	return loadout
// }