global function CanDropTitanChassis

bool function CanDropTitanChassis( entity player )
{
    string chassis = playerToChassis( player )
    int titanCount = 0

    foreach ( entity titan in GetEntArrayByClass_Expensive("npc_titan") )
    {
        if ( titan.GetTeam() == player.GetTeam() && chassis == GetTitanChassis( titan )  )
        {
            titanCount += 1
        }
    }
    foreach ( entity p in GetPlayerArray() )
    {
        if ( p.GetTeam() == player.GetTeam() && p.IsTitan() && chassis == GetTitanChassis( p ) )
        {
            titanCount += 1
        }
    }

    return titanCount < GetChassisLimit( chassis )
}

int function GetChassisLimit( string chassis )
{
    switch ( chassis )
    {
        case "ogre":
            return GetConVarInt("OgreLimit")
        case "stryder":
            return GetConVarInt("StryderLimit")
        case "atlas":
            return GetConVarInt("AtlasLimit")
    }
    unreachable
}

string function playerToChassis( entity player )
{
    string chassis = GetActiveTitanLoadout( player ).titanClass
    switch ( chassis )
    {
        case "ronin":
        case "northstar":
            return "stryder" 
        case "tone":
        case "vanguard":
        case "ion":
            return "atlas"
        case "legion":
        case "scorch":
            return "ogre" 
    }
    unreachable
}